﻿EnableExplicit


XIncludeFile "zeitschaltuhr.pbf"
XIncludeFile "aufgabe.pbf"

; ### Erweiterung:
; ### alle '$00 Bytes' mit Zufallwerten auffüllen, dann AES128-Verschlüsselung

Global.s OutName1, OutName2, OutName3, OutName4, OutName5, OutName6, OutName7, OutName8
Global Event, ConnectionID.l, bytecnt.i
Global Port.l, IPAddress.s 
Global *EBuffer = AllocateMemory(1800)
Global *SBuffer = AllocateMemory(16)

Declare SetOutputTxt()
Declare SendGlobalRequest(EventType)
Declare SendKeepAlive(*X)

If OpenPreferences("zeitschaltuhr.ini", #PB_Preference_GroupSeparator)
  PreferenceGroup("Global")
  IPAddress = ReadPreferenceString("IPAddress", "127.0.0.1")
  Port = ReadPreferenceLong("Port", 6832)
  PreferenceGroup("OutputNames")
  OutName1 = ReadPreferenceString("OutName1", "Ausgang 1")
  OutName2 = ReadPreferenceString("OutName2", "Ausgang 2")
  OutName3 = ReadPreferenceString("OutName3", "Ausgang 3")
  OutName4 = ReadPreferenceString("OutName4", "Ausgang 4")
  OutName5 = ReadPreferenceString("OutName5", "Ausgang 5")
  OutName6 = ReadPreferenceString("OutName6", "Ausgang 6")
  OutName7 = ReadPreferenceString("OutName7", "Ausgang 7")
  OutName8 = ReadPreferenceString("OutName8", "Ausgang 8")
  ClosePreferences()
Else
  MessageRequester("Error", "Can't open the file 'zeitschaltuhr.ini'.", #MB_ICONERROR)
  End
EndIf 

If InitNetwork() = #False
  MessageRequester("Error", "Can't initialize the network.", #MB_ICONERROR)
  End
EndIf

OpenWindowMain()
RemoveGadgetColumn(lst_0, 0)
AddGadgetColumn(lst_0, 0, "", 0)
AddGadgetColumn(lst_0, 1, "Wochentage", 140)
AddGadgetColumn(lst_0, 2, "Zeit", 50)
AddGadgetColumn(lst_0, 3, "1", 20)
AddGadgetColumn(lst_0, 4, "2", 20)
AddGadgetColumn(lst_0, 5, "3", 20)
AddGadgetColumn(lst_0, 6, "4", 20)
AddGadgetColumn(lst_0, 7, "5", 20)
AddGadgetColumn(lst_0, 8, "6", 20)
AddGadgetColumn(lst_0, 9, "7", 20)
AddGadgetColumn(lst_0, 10, "8", 40)
AddGadgetColumn(lst_0, 11, "aktiv", 35)
AddGadgetColumn(lst_0, 12, "löschen", 50)
SetOutputTxt() ; Texte der Ausgangs-Checkboxen setzen
; AddWindowTimer(WindowMain, 114, 10000) ; keep-alive-timer: periodic task 10 Sek.
ConnectionID = OpenNetworkConnection(IPAddress, Port)
If ConnectionID = #False ; wenn die Netzwerkverbindung fehl schlägt
  MessageRequester("Fehler", "Mit dem Server ist keine Verbindung möglich." + #LF$ + #LF$ +
                             "Bitte prüfen:" + #LF$ +
                             "- Der Server ist eingeschaltet." + #LF$ +
                             "- In der INI-Datei steht die richtige IP-Adresse." + #LF$ +
                             "- Die Firewalleinstellungen sind angepasst.", #MB_ICONERROR)
  End
EndIf

Global Mutex
Mutex = CreateMutex()
CreateThread(@SendKeepAlive(), 0)

SendGlobalRequest(0)


Procedure SetTxtStd(EventType)
  ; zweistellige Anzeige im Gadget erzwingen
  SetGadgetText(spi_std, RSet(Str(GetGadgetState(spi_std)), 2, "0")) 
EndProcedure 


Procedure SetTxtMin(EventType)
  ; zweistellige Anzeige im Gadget erzwingen
  SetGadgetText(spi_min, RSet(Str(GetGadgetState(spi_min)), 2, "0")) 
EndProcedure 


Procedure SetCheckSum()
  ; erzeugt die Checksumme  und schreibt sie an Pos. 11 in den *SBuffer  
  Define temp.a, ii.a
  For ii = 0 To 14
    temp = temp ! PeekA(*SBuffer+ii) ; EXOR
  Next
  PokeA(*SBuffer+15, temp)
EndProcedure  


Procedure VerifyCheckSum(pos.i)
  ; prüft die Checksumme, bei OK kommt 1 zurück  -  "pos" ist die Position der Checksumme im *EBuffer  
  Define temp.a, ii.a
  For ii = 0 To pos - 1
    temp = temp ! PeekA(*EBuffer+ii) ; EXOR
  Next
  If temp = PeekA(*EBuffer+pos)
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure  


Procedure ClrSBuffer()
  ; löscht den SendeBuffer
  Define ii.i
  For ii = 0 To 14
    PokeA(*SBuffer+ii, $00)
  Next
EndProcedure


Procedure ChangeIpAndPort(EventType)
  ; send a IP-Port-Frame and alter the IPAdress and Port in the INI-File 
  Define temp.s
  If MessageRequester("IP-Adresse und Port ändern", 
    "Wenn Sie unten auf 'Ja' klicken öffnet sich ein neues Dialogfenster." + #LF$ + #LF$ +
    "Geben Sie in diesem Dialogfenster die" + #LF$ + 
    "neue IP-Adresse und den Port ein." + #LF$ + 
    "Drücken Sie dann 'OK'." + #LF$ + #LF$ +
    "Wollen Sie IP-Adresse und Port der Wochenschaltuhr ändern?",
     #PB_MessageRequester_Info | #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
    Delay(100)    
      temp = InputRequester("IP-Adresse und Port eingeben", 
                            "Beispiel: 192.168.1.1:6832",
                             IPAddress + ":" + Str(Port))
      If temp <> ""
        IPAddress = StringField(temp, 1, ":")
        Port = Val(StringField(temp, 2, ":"))
        OpenPreferences("zeitschaltuhr.ini", #PB_Preference_GroupSeparator)
        PreferenceGroup("Global")
        WritePreferenceString("IPAddress", IPAddress)
        WritePreferenceLong("Port", Port)
        ClosePreferences()
; $55, $A9, $00, $00, $00, $00, $00, $00, $00, IP4, IP3, IP2, IP1, PortL, PortH, Checksumme 
        LockMutex(Mutex)
        ClrSBuffer()
        PokeA(*SBuffer, $55)    ; Start
        PokeA(*SBuffer+1, $A9)  ; IP-Port-Frame-Kennung
        PokeA(*SBuffer+9, Val(StringField(IPAddress, 4, ".")))
        PokeA(*SBuffer+10, Val(StringField(IPAddress, 3, ".")))
        PokeA(*SBuffer+11, Val(StringField(IPAddress, 2, "."))) 
        PokeA(*SBuffer+12, Val(StringField(IPAddress, 1, ".")))
        PokeA(*SBuffer+13, Port % 256)
        PokeA(*SBuffer+14, Port / 256) 
        SetCheckSum()
        SendNetworkData(ConnectionID, *SBuffer, 16)
        UnlockMutex(Mutex)
        Delay(1000)
        End
      EndIf  
  EndIf
EndProcedure 


Procedure SendRealTime(EventType)
  ; Request a RealTime-Frame: $55, $A8, $00, $00, $00, $00, $00, $00, $00, $00, $00, Sekunden, Minuten, Stunden, Wochentag, Checksumme 
  LockMutex(Mutex)
  ClrSBuffer()
  PokeA(*SBuffer, $55)    ; Start
  PokeA(*SBuffer+1, $A8)  ; RealTime-Kennung
  PokeA(*SBuffer+11, Second(Date())) 
  PokeA(*SBuffer+12, Minute(Date()))
  PokeA(*SBuffer+13, Hour(Date()))
  Define tmp.a = DayOfWeek(Date())
  If tmp = 0 : tmp = 7 : EndIf
  PokeA(*SBuffer+14, tmp)  ; Wochentag: 1...7, Mo. = 1
  SetCheckSum()
  SendNetworkData(ConnectionID, *SBuffer, 16)
  UnlockMutex(Mutex)  
EndProcedure 


Procedure SendGlobalRequest(EventType)
  ; Request a Global-Frame: $55, $AB, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, Checksumme 
  LockMutex(Mutex)
  ClrSBuffer()
  PokeA(*SBuffer, $55)    ; Start
  PokeA(*SBuffer+1, $AB)  ; Request-Kennung
  SetCheckSum()
  SendNetworkData(ConnectionID, *SBuffer, 16)
  UnlockMutex(Mutex)  
EndProcedure 


Procedure SendKeepAlive(*X)
  ; Send a Keep-Alive-Frame: $55, $AF, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, Checksumme 
  ; runs in a separate thread
  Repeat
    Delay(10000)
    LockMutex(Mutex)
    ClrSBuffer()
    PokeA(*SBuffer, $55)    ; Start
    PokeA(*SBuffer+1, $AF)  ; Request-Kennung
    SetCheckSum()
    SendNetworkData(ConnectionID, *SBuffer, 16)
    UnlockMutex(Mutex)  
  ForEver
EndProcedure 




Procedure SetOutputState(status.a)
  ; Häkchen der Ausgangs-Checkboxen setzen
  SetGadgetState(chk_state1, status & %00000001)
  SetGadgetState(chk_state2, status & %00000010)
  SetGadgetState(chk_state3, status & %00000100)
  SetGadgetState(chk_state4, status & %00001000)
  SetGadgetState(chk_state5, status & %00010000)
  SetGadgetState(chk_state6, status & %00100000)
  SetGadgetState(chk_state7, status & %01000000)
  SetGadgetState(chk_state8, status & %10000000)
EndProcedure


Procedure SetAutomaticState(status.a)
  ; Häkchen der Ausgangs-Checkboxen setzen
  SetGadgetState(chk_auto1, status & %00000001)
  SetGadgetState(chk_auto2, status & %00000010)
  SetGadgetState(chk_auto3, status & %00000100)
  SetGadgetState(chk_auto4, status & %00001000)
  SetGadgetState(chk_auto5, status & %00010000)
  SetGadgetState(chk_auto6, status & %00100000)
  SetGadgetState(chk_auto7, status & %01000000)
  SetGadgetState(chk_auto8, status & %10000000)
EndProcedure


Procedure SetOutputTxt()
  ; Texte der Ausgangs-Checkboxen setzen
  SetGadgetText(chk_state1, "1 - " + OutName1)
  SetGadgetText(chk_state2, "2 - " + OutName2)
  SetGadgetText(chk_state3, "3 - " + OutName3)
  SetGadgetText(chk_state4, "4 - " + OutName4)
  SetGadgetText(chk_state5, "5 - " + OutName5)
  SetGadgetText(chk_state6, "6 - " + OutName6)
  SetGadgetText(chk_state7, "7 - " + OutName7)
  SetGadgetText(chk_state8, "8 - " + OutName8)
EndProcedure


Procedure ChangeEvent(EventType)
  ; öffnet das Fenster "Aufgabe" wenn ein Eintrag markiert ist für eine Änderung
  If GetGadgetState(lst_0) > -1
    ShowEvent(#PB_EventType_LeftDoubleClick)
  EndIf  
EndProcedure


Procedure NewEvent(EventType)
  ; öffnet das Fenster "Aufgabe" für einen neuen Eintrag
  SetGadgetState(lst_0, -1)
  ShowEvent(#PB_EventType_LeftDoubleClick)
EndProcedure


Procedure ShowEvent(EventType)
  ; Ereignis-Einstellen-Fenster öffnen
  Define index.i, zeit.s, wotage.s
  If EventType = #PB_EventType_LeftDoubleClick
    index = GetGadgetState(lst_0)
    OpenWindowZeit() ; Fenster öffnen
    If index = -1 
      ; mit jungfräulicher Gadget-Einstellung
      SetWindowTitle(WindowZeit, "Neue Aufgabe hinzufügen") 
      SetGadgetState (spi_min, 30) ; SpinGadget Anfangswert festlegen
      SetGadgetState (spi_std, 12) ; SpinGadget Anfangswert festlegen
    Else  
      ; mit der Gadget-Einstellung gemäß dem ausgewählten Eintrag
      zeit = GetGadgetItemText(lst_0, index, 2)
      wotage = GetGadgetItemText(lst_0, index, 1)
      SetGadgetState (spi_min, Val(Mid(zeit, 4, 2))) ; SpinGadget
      SetGadgetState (spi_std, Val(Mid(zeit, 1, 2))) ; SpinGadget
      ; Wochentage
      If FindString(wotage, "Mo") : SetGadgetState(che_mon, 1) : EndIf
      If FindString(wotage, "Di") : SetGadgetState(che_die, 1) : EndIf
      If FindString(wotage, "Mi") : SetGadgetState(che_mit, 1) : EndIf
      If FindString(wotage, "Do") : SetGadgetState(che_don, 1) : EndIf
      If FindString(wotage, "Fr") : SetGadgetState(che_fre, 1) : EndIf
      If FindString(wotage, "Sa") : SetGadgetState(che_sam, 1) : EndIf
      If FindString(wotage, "So") : SetGadgetState(che_son, 1) : EndIf
      ; Flags
      If GetGadgetItemText(lst_0, index, 11) = "" : SetGadgetState(che_dea, 1) : EndIf ; deaktiviert   
      If GetGadgetItemText(lst_0, index, 12) <> "" : SetGadgetState(che_loe, 1) : EndIf ; löschen
      ; Ausgänge
      Select GetGadgetItemText(lst_0, index, 3)
        Case "E" : SetGadgetState(opt_1ei, 1) : Case "A" : SetGadgetState(opt_1au, 1) : Case "I" : SetGadgetState(opt_1im, 1) : Default : SetGadgetState(opt_1gl, 1)
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 4)
        Case "E" : SetGadgetState(opt_2ei, 1) : Case "A" : SetGadgetState(opt_2au, 1) : Case "I" : SetGadgetState(opt_2im, 1) : Default : SetGadgetState(opt_2gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 5)
        Case "E" : SetGadgetState(opt_3ei, 1) : Case "A" : SetGadgetState(opt_3au, 1) : Case "I" : SetGadgetState(opt_3im, 1) : Default : SetGadgetState(opt_3gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 6)
        Case "E" : SetGadgetState(opt_4ei, 1) : Case "A" : SetGadgetState(opt_4au, 1) : Case "I" : SetGadgetState(opt_4im, 1) : Default : SetGadgetState(opt_4gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 7)
        Case "E" : SetGadgetState(opt_5ei, 1) : Case "A" : SetGadgetState(opt_5au, 1) : Case "I" : SetGadgetState(opt_5im, 1) : Default : SetGadgetState(opt_5gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 8)
        Case "E" : SetGadgetState(opt_6ei, 1) : Case "A" : SetGadgetState(opt_6au, 1) : Case "I" : SetGadgetState(opt_6im, 1) : Default : SetGadgetState(opt_6gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 9)
        Case "E" : SetGadgetState(opt_7ei, 1) : Case "A" : SetGadgetState(opt_7au, 1) : Case "I" : SetGadgetState(opt_7im, 1) : Default : SetGadgetState(opt_7gl, 1) 
      EndSelect    
      Select GetGadgetItemText(lst_0, index, 10)
        Case "E" : SetGadgetState(opt_8ei, 1) : Case "A" : SetGadgetState(opt_8au, 1) : Case "I" : SetGadgetState(opt_8im, 1) : Default : SetGadgetState(opt_8gl, 1) 
      EndSelect    
    EndIf  
    SetGadgetText(str_1, OutName1)
    SetGadgetText(str_2, OutName2)
    SetGadgetText(str_3, OutName3)
    SetGadgetText(str_4, OutName4)
    SetGadgetText(str_5, OutName5)
    SetGadgetText(str_6, OutName6)
    SetGadgetText(str_7, OutName7)
    SetGadgetText(str_8, OutName8)
  EndIf
EndProcedure


; Event-Delete-Frame: $55, $AE, $00, $00, Index, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, Checksumme   
Procedure DeleteEvent(EventType)
  ; Aufgabe löschen und Ereignis-Einstellen-Fenster schliessen
  Define index.i = GetGadgetState(lst_0) 
  Define number.a
  If index > -1 
    number = Val(GetGadgetItemText(lst_0, index, 0)) ; den Nummerneintrag bei dem markierten List-Index auslesen 
    LockMutex(Mutex)
    ClrSBuffer()
    PokeA(*SBuffer, $55)      ; Start
    PokeA(*SBuffer+1, $AE)    ; Event-Delete-Kennung
    PokeA(*SBuffer+4, number)
    SetCheckSum()
    SendNetworkData(ConnectionID, *SBuffer, 16)    
    UnlockMutex(Mutex)  
    If IsWindow(WindowZeit)
      If EventType > 0  ; Wenn diese Procedure von der Procedur "SetEvent()" aufgerufen wurde: Das Fenster nicht schließen. 
        CloseWindow(WindowZeit)
      EndIf  
    EndIf
    Delay(100)
  EndIf
  SendGlobalRequest(0)
EndProcedure


Procedure GetNextFreeListboxNumber()
  Define ii.a, jj.a, exist 
  Define upper.a = CountGadgetItems(lst_0)
  ;
  For jj = 0 To upper ; alle Werte durchprobieren bis zu dem Wert Anzahl_der_Einträge 
    exist = #False
    For ii = 0 To upper - 1
      If jj = Val(GetGadgetItemText(lst_0, ii, 0))
        exist = #True
        Break
      EndIf  
    Next
    If exist = #False
      ProcedureReturn jj ; gibt den niedrigsten freien Wert zurück, spätestens der Wert Anzahl_der_Einträge ist frei
    EndIf  
  Next  
EndProcedure


; Event-Set-Frame: $55, $AB, $00, $00, *Index, *Zeit-L, *Zeit-H, *Ausgänge-Ein, *Ausgänge-Aus, *Ausgänge-Impuls, *Deaktiv-Löschen, $00, $00, $00, $00, Checksumme   
Procedure SendNewEvent(nbr.a, zeit.i) 
  ; sendet eine Aufgabe zur Schaltuhr
  Define ein.a, aus.a, impuls.a, flags.a, zh.a, zl.a, ii.i
  zeit = zeit + (GetGadgetState(spi_std) * 60)
  zeit = zeit + GetGadgetState(spi_min)
  zh = zeit / 256
  zl = zeit & 255
  ; Einschaltwerte zusammenfassen
  If GetGadgetState(opt_1ei) = 1 : ein | %00000001 : EndIf
  If GetGadgetState(opt_2ei) = 1 : ein | %00000010 : EndIf
  If GetGadgetState(opt_3ei) = 1 : ein | %00000100 : EndIf
  If GetGadgetState(opt_4ei) = 1 : ein | %00001000 : EndIf
  If GetGadgetState(opt_5ei) = 1 : ein | %00010000 : EndIf
  If GetGadgetState(opt_6ei) = 1 : ein | %00100000 : EndIf
  If GetGadgetState(opt_7ei) = 1 : ein | %01000000 : EndIf
  If GetGadgetState(opt_8ei) = 1 : ein | %10000000 : EndIf
  ; Ausschaltwerte zusammenfassen  
  If GetGadgetState(opt_1au) = 1 : aus | %00000001 : EndIf
  If GetGadgetState(opt_2au) = 1 : aus | %00000010 : EndIf
  If GetGadgetState(opt_3au) = 1 : aus | %00000100 : EndIf
  If GetGadgetState(opt_4au) = 1 : aus | %00001000 : EndIf
  If GetGadgetState(opt_5au) = 1 : aus | %00010000 : EndIf
  If GetGadgetState(opt_6au) = 1 : aus | %00100000 : EndIf
  If GetGadgetState(opt_7au) = 1 : aus | %01000000 : EndIf
  If GetGadgetState(opt_8au) = 1 : aus | %10000000 : EndIf
  ; Impulswerte zusammenfassen  
  If GetGadgetState(opt_1im) = 1 : impuls | %00000001 : EndIf
  If GetGadgetState(opt_2im) = 1 : impuls | %00000010 : EndIf
  If GetGadgetState(opt_3im) = 1 : impuls | %00000100 : EndIf
  If GetGadgetState(opt_4im) = 1 : impuls | %00001000 : EndIf
  If GetGadgetState(opt_5im) = 1 : impuls | %00010000 : EndIf
  If GetGadgetState(opt_6im) = 1 : impuls | %00100000 : EndIf
  If GetGadgetState(opt_7im) = 1 : impuls | %01000000 : EndIf
  If GetGadgetState(opt_8im) = 1 : impuls | %10000000 : EndIf
  ; Deaktiviert und Löschen Flags zusammenfassen  
  flags = %00000001
  If GetGadgetState(che_dea) = 1 : flags & %11111110 : EndIf
  If GetGadgetState(che_loe) = 1 : flags | %00000010 : EndIf
  ; Sende-Frame laden
  PokeA(*SBuffer, $55)      ; Start
  PokeA(*SBuffer+1, $AC)    ; Event-Send-Kennung
  PokeA(*SBuffer+2, $00)
  PokeA(*SBuffer+3, $00)
  PokeA(*SBuffer+4, nbr) 
  PokeA(*SBuffer+5, zl)
  PokeA(*SBuffer+6, zh)
  PokeA(*SBuffer+7, ein)
  PokeA(*SBuffer+8, aus)
  PokeA(*SBuffer+9, impuls)
  PokeA(*SBuffer+10, flags)
  SetCheckSum()
  LockMutex(Mutex)
  SendNetworkData(ConnectionID, *SBuffer, 16)
  UnlockMutex(Mutex)  
  Delay(100)
EndProcedure


Procedure SetEvent(EventType)
  ; Event-Einstellungen übernehmen und Ereignis-Einstellen-Fenster schliessen
  ; Wenn eine Aufgabe an mehreren Tagen stattfindet, muss für jeden Wochentag ein Event eingetragen werden.
  Define nbr.a = GetNextFreeListboxNumber()
  DeleteEvent(0) ; sofern ein Eintrag ausgewählt ist, diesen vorher löschen (Aufgabe ändern Modus)
  
  If GetGadgetState(che_mon) = 1
    SendNewEvent(nbr, 0) ; Mo
  EndIf 
  If GetGadgetState(che_die) = 1
    SendNewEvent(nbr, 1440) ; Di
  EndIf  
  If GetGadgetState(che_mit) = 1
    SendNewEvent(nbr, 2880) ; Mi
  EndIf  
  If GetGadgetState(che_don) = 1
    SendNewEvent(nbr, 4320) ; Do
  EndIf  
  If GetGadgetState(che_fre) = 1
    SendNewEvent(nbr, 5760) ; Fr
  EndIf  
  If GetGadgetState(che_sam) = 1
    SendNewEvent(nbr, 7200) ; Sa
  EndIf  
  If GetGadgetState(che_son) = 1
    SendNewEvent(nbr, 8640) ; So
  EndIf  
  ; Bezeichnungen der Ausgänge übernehmen
  OutName1 = GetGadgetText(str_1)
  OutName2 = GetGadgetText(str_2)
  OutName3 = GetGadgetText(str_3)
  OutName4 = GetGadgetText(str_4)
  OutName5 = GetGadgetText(str_5)
  OutName6 = GetGadgetText(str_6)
  OutName7 = GetGadgetText(str_7)
  OutName8 = GetGadgetText(str_8)
  CloseWindow(WindowZeit)
  SetOutputTxt()
  SendGlobalRequest(0)
EndProcedure


Procedure Abbrechen(EventType)
  ; Ereignis-Einstellen-Fenster schliessen
  CloseWindow(WindowZeit)
EndProcedure


Procedure Beenden(EventType)
  ; Programm beenden
  Event = #PB_Event_CloseWindow
EndProcedure


; Output-Set-Frame: $55, $AD, Ausgangsstatus, Automatikstatus, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, Checksumme   
Procedure UpdateOutputs(EventType)
  ; Ausgangswerte zur Hardware schicken
  Define output.a
  If GetGadgetState(chk_state1) = 1 : output | %00000001 : EndIf
  If GetGadgetState(chk_state2) = 1 : output | %00000010 : EndIf
  If GetGadgetState(chk_state3) = 1 : output | %00000100 : EndIf
  If GetGadgetState(chk_state4) = 1 : output | %00001000 : EndIf
  If GetGadgetState(chk_state5) = 1 : output | %00010000 : EndIf
  If GetGadgetState(chk_state6) = 1 : output | %00100000 : EndIf
  If GetGadgetState(chk_state7) = 1 : output | %01000000 : EndIf
  If GetGadgetState(chk_state8) = 1 : output | %10000000 : EndIf
  Define auto.a
  If GetGadgetState(chk_auto1) = 1 : auto | %00000001 : EndIf
  If GetGadgetState(chk_auto2) = 1 : auto | %00000010 : EndIf
  If GetGadgetState(chk_auto3) = 1 : auto | %00000100 : EndIf
  If GetGadgetState(chk_auto4) = 1 : auto | %00001000 : EndIf
  If GetGadgetState(chk_auto5) = 1 : auto | %00010000 : EndIf
  If GetGadgetState(chk_auto6) = 1 : auto | %00100000 : EndIf
  If GetGadgetState(chk_auto7) = 1 : auto | %01000000 : EndIf
  If GetGadgetState(chk_auto8) = 1 : auto | %10000000 : EndIf
  LockMutex(Mutex)
  ClrSBuffer()
  PokeA(*SBuffer, $55)        ; Start
  PokeA(*SBuffer+1, $AD)      ; Kennung Sende-Ausgangs-Status 
  PokeA(*SBuffer+2, output)   ; Ausgangsstatus
  PokeA(*SBuffer+3, auto)     ; Automatikstatus
  SetCheckSum()
  SendNetworkData(ConnectionID, *SBuffer, 16)
  UnlockMutex(Mutex)  
EndProcedure


Procedure IsNumberExist(number.a)
  ; prüft die Nummer, ob sie schon vorhanden ist und liefert ggf. den Index zurück 
  Define ii.i = 0
  Define upper.a = CountGadgetItems(lst_0)
  ;
  While ii < upper
    If number = Val(GetGadgetItemText(lst_0, ii, 0))
      ProcedureReturn ii 
    EndIf  
    ii + 1
  Wend  
  ProcedureReturn -1
EndProcedure


; Erwarteter Frame: $55, $AA, Ausgangsstatus, Auto, Aufgaben-L, Aufgaben-H, *Nummer, *Zeit-L, *Zeit-H, *Ausgänge-Ein, *Ausgänge-Aus, *Ausgänge-Impuls, *Flags, Checksumme   
Procedure FillEventList()
  Dim Out.s(7)
  Define shifter.a, ii.i, jj.i, offset.i, index.i, number.a, temp.i, minuten.a, stunden.a, tage.a   
  Define zeit.s   ; "23:55"
  Define wotag.s  ; "Mo, Di, Mi, Do, Fr, Sa, So"
  Define aktiv.s
  Define loesch.s
  ClearGadgetItems(lst_0) 
  jj = 0
  offset = 0
  While jj < PeekU(*EBuffer+4)  ; Aufgaben L-Wert + H-Wert
    number = PeekA(*EBuffer+6+offset)
    index = IsNumberExist(number)
    ; Zeitpunkt dekodieren und z.T. formatieren
    wotag = ""  
    temp = PeekU(*EBuffer+7+offset) ; alle Minuten bis zum Ereignis
    tage = temp / 1440 
    temp = temp % 1440    ; alle Minuten ohne die Tage
    stunden = temp / 60
    minuten = temp % 60   ; nur die Minuten
    Select tage
      Case 0
        wotag + "Mo"
      Case 1
        wotag + "Di"
      Case 2
        wotag + "Mi"
      Case 3
        wotag + "Do"
      Case 4
        wotag + "Fr"
      Case 5
        wotag + "Sa"
      Case 6
        wotag + "So"
    EndSelect    
    If index > -1
      ; wenn die Nummer vom Eintrrag schon existiert muß nur der Wochentag zugefügt werden
      SetGadgetItemText(lst_0, index, GetGadgetItemText(lst_0, index, 1) + ", " + wotag, 1)
    Else
      ; Ausgänge formatieren
      shifter.a = %00000001
      For ii = 0 To 7
        Out(ii) = "-"
        If PeekA(*EBuffer+9+offset) & shifter
          Out(ii) = "E"
        EndIf
        If PeekA(*EBuffer+10+offset) & shifter
          Out(ii) = "A"
        EndIf
        If PeekA(*EBuffer+11+offset) & shifter
          Out(ii) = "I"
        EndIf
        shifter << 1
      Next
      ; Flags formatieren
      aktiv = ""
      loesch = ""
      If PeekA(*EBuffer+12+offset) & %00000001 : aktiv = "X" : EndIf
      If PeekA(*EBuffer+12+offset) & %00000010 : loesch = "X" : EndIf
      ; Zeiteintrag formatieren
      zeit = RSet(Str(stunden), 2, "0") + ":" + RSet(Str(minuten), 2, "0") 
      ; Eintrag am Ende der Liste zufügen
      AddGadgetItem(lst_0, -1, Str(number)+Chr(10)+wotag+Chr(10)+zeit+Chr(10)+Out(0)+Chr(10)+Out(1)+Chr(10)+Out(2)+
                               Chr(10)+Out(3)+Chr(10)+Out(4)+Chr(10)+Out(5)+Chr(10)+Out(6)+Chr(10)+Out(7)+Chr(10)+aktiv+Chr(10)+loesch)
    EndIf
    jj + 1
    offset + 7
  Wend
EndProcedure


Repeat
  Event = WaitWindowEvent(20)
  WindowMain_Events(Event)
  If IsWindow(WindowZeit)     ; wenn das Ereignis-Einstellen-Fenster geöffnet ist ...
    WindowZeit_Events(Event)  ; ... das entsprechende Event-Menü abfragen
    If Event = #PB_Event_DeactivateWindow  ; wenn das Ereignis-Einstellen-Fenster den Focus verloren hat ...
      SetActiveWindow(WindowZeit)          ; ... den Focus wieder zurück setzen
    EndIf  
  EndIf
  ;
;  If Event = #PB_Event_Timer And EventTimer() = 114
;    SendKeepAlive()
;  EndIf
  ;
  If NetworkClientEvent(ConnectionID) = #PB_NetworkEvent_Data
    ; Erwarteter Frame: $55, $AA, Ausgangsstatus, Automatikstatus, Aufgaben-L, Aufgaben-H, *Nummer, *Zeit-L, *Zeit-H, *Ausgänge-Ein, *Ausgänge-Aus, *Ausgänge-Impuls, *Deaktiv-Löschen, Checksumme   
    bytecnt = ReceiveNetworkData(ConnectionID, *EBuffer, 1800)
    If PeekA(*EBuffer+1) = $AA And VerifyCheckSum(bytecnt -1)  
      SetOutputState(PeekA(*EBuffer+2)) ; Häkchen der Ausgangs-Checkboxen setzen
      SetAutomaticState(PeekA(*EBuffer+3)) ; Häkchen der Automatic-Checkboxen setzen
      FillEventList()
    EndIf
  EndIf  
Until Event = #PB_Event_CloseWindow
;
CloseNetworkConnection(ConnectionID)
; Bezeichnungen der Ausgänge in die ini-Datei schreiben
OpenPreferences("zeitschaltuhr.ini", #PB_Preference_GroupSeparator)
PreferenceGroup("OutputNames")
WritePreferenceString("OutName1", OutName1)
WritePreferenceString("OutName2", OutName2)
WritePreferenceString("OutName3", OutName3)
WritePreferenceString("OutName4", OutName4)
WritePreferenceString("OutName5", OutName5)
WritePreferenceString("OutName6", OutName6)
WritePreferenceString("OutName7", OutName7)
WritePreferenceString("OutName8", OutName8)
ClosePreferences()

End


; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 436
; Folding = -----
; EnableXP